class Bug
{
  // instance data
  private int x;
  private int y;
  private int moveDirection;
  private int moveAmount;
  
  // instance methods
  //constructor
  public Bug (int x, int y)
  {
    this.x = x; // assign local x to class x
    this.y = y;
    moveDirection = 1; // right
    moveAmount = 1; // 1 pixel per frame
  }
  
  public void display()
  {
    fill(0);
    ellipse(x, y, 40, 40); // thorax
    ellipse(x, y-30, 30, 20); // head
    ellipse(x, y+50, 40, 60); // abdomen
  }
  
  public void move()
  {
    x = x + (moveDirection * moveAmount);
    
    if (x > 480 && moveDirection > 0)
    {
      moveDirection = -1;
    }
    
    if (x < 20 && moveDirection < 0)
    {
      moveDirection = 1;
    }
  }
  
  public void speedUp()
  {
    moveAmount = moveAmount + 2;
  }
  
  public boolean wasClicked(int x1, int y1)
  {
    if (y1 > (y - 40) && y1 < (y + 80) && 
        x1 > (x - 20) && x1 < (x + 20))
    {
      return true;
    }
    else
    {
      return false;
    }
  }
  
  // TO BE CONTINUED
  
}

Bug b1, b2, b3;

void setup()
{
  size(500, 500);
  b1 = new Bug(int(random(500)), int(random(500)));
  b2 = new Bug(int(random(500)), int(random(500)));
  b3 = new Bug(int(random(500)), int(random(500)));
}

void draw ()
{
  background(150);
  b1.display();
  b2.display();
  b3.display();
  
  b1.move();
  b2.move();
  b3.move();
}

public void mousePressed()
{
  if (b1.wasClicked(mouseX, mouseY))
  {
    b1.speedUp();
  }
  
  if (b2.wasClicked(mouseX, mouseY))
  {
    b2.speedUp();
  }
  
  if (b3.wasClicked(mouseX, mouseY))
  {
    b3.speedUp();
  }
}